BuyPlaceableHeapEvent = {}
BuyPlaceableHeapEvent_mt = Class(BuyPlaceableHeapEvent, BuyPlacableEvent)

function BuyPlaceableHeapEvent:new(placeableType,filename, x, y, z, rx, ry, rz)
  local self = BuyPlaceableEvent:emptyNew()
  self.placeableType=placeableType
  self.filename = filename
  self.x = x
  self.y = y
  self.z = z
  self.rx = rx
  self.ry = ry
  self.rz = rz
  self.successful=true;
  return self
end

function BuyPlaceableEvent:run(connection)
	local classObject = PlacementScreen.placeableTypes[self.placeableType]
	local placeable
	if classObject ~= nil then
		placeable = classObject:new(g_currentMission:getIsServer(), g_currentMission:getIsClient())
		if placeable:load(self.filename, self.x, self.y, self.z, self.rx, self.ry, self.rz, false)then
			placeable:register()
		else
			print("Error: Failed to load placeable '" .. self.filename .. "'")
			placeable:delete()
			placeable = nil
		end;
	else
		print("Error: Invalid placeable type '" .. placeableType .. "'")
	end
end
